<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/AVSCommon/AVS/include/AVSCommon/AVS/CapabilityAgent.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_13e65effb2bde530b17b3d5eefcd0266.html">AVSCommon</a></li><li class="navelem"><a class="el" href="dir_80711c2a226d5fced33fce22558d3784.html">AVS</a></li><li class="navelem"><a class="el" href="dir_a8d3deb3c1282038af9ce4454694c1e1.html">include</a></li><li class="navelem"><a class="el" href="dir_4c314a0d19d1aa5c860795d42a926e2c.html">AVSCommon</a></li><li class="navelem"><a class="el" href="dir_1b86ff6fe19386d1d992f6fa0aca02b2.html">AVS</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">CapabilityAgent.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_capability_agent_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_AVSCOMMON_AVS_INCLUDE_AVSCOMMON_AVS_CAPABILITYAGENT_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_AVSCOMMON_AVS_INCLUDE_AVSCOMMON_AVS_CAPABILITYAGENT_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;atomic&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;unordered_map&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_namespace_and_name_8h.html">AVSCommon/AVS/NamespaceAndName.h</a>&quot;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_exception_encountered_sender_interface_8h.html">AVSCommon/SDKInterfaces/ExceptionEncounteredSenderInterface.h</a>&quot;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_channel_observer_interface_8h.html">AVSCommon/SDKInterfaces/ChannelObserverInterface.h</a>&quot;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_context_requester_interface_8h.html">AVSCommon/SDKInterfaces/ContextRequesterInterface.h</a>&quot;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_state_provider_interface_8h.html">AVSCommon/SDKInterfaces/StateProviderInterface.h</a>&quot;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_directive_handler_interface_8h.html">AVSCommon/SDKInterfaces/DirectiveHandlerInterface.h</a>&quot;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_directive_handler_result_interface_8h.html">AVSCommon/SDKInterfaces/DirectiveHandlerResultInterface.h</a>&quot;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">namespace </span>avsCommon {</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">namespace </span>avs {</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html">   47</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html">CapabilityAgent</a></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html">sdkInterfaces::DirectiveHandlerInterface</a></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_channel_observer_interface.html">sdkInterfaces::ChannelObserverInterface</a></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface.html">sdkInterfaces::StateProviderInterface</a></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_requester_interface.html">sdkInterfaces::ContextRequesterInterface</a> {</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#ab6745fae4f7b144f64d34251c76d14f7">~CapabilityAgent</a>() = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="comment">/*</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment">     * DirectiveHandlerInterface functions.</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment">     *</span></div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="comment">     * The following four functions implement the @c DirectiveHandlerInterface. Only the message Id is passed to the</span></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="comment">     * @c handleDirective and @c cancelDirective functions, so we need to maintain a mapping of the message Id to the</span></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="comment">     * @c AVSDirective and @c DirectiveHandlerResultInterface, i.e., @c DirectiveAndResultInterface. The</span></div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="comment">     * @c DirectiveHandlerInterface functions call the functions of the same name with the</span></div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="comment">     * @c DirectiveAndResultInterface as the argument.</span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="comment">     */</span></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a6643447cdbecc1e49e14532b0cc83cf1">preHandleDirective</a>(</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        std::shared_ptr&lt;AVSDirective&gt; directive,</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        std::unique_ptr&lt;sdkInterfaces::DirectiveHandlerResultInterface&gt; result) <span class="keyword">override</span> <span class="keyword">final</span>;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a971352c6a79f7cb000e5e632648bceb3">handleDirective</a>(<span class="keyword">const</span> std::string&amp; messageId) <span class="keyword">override</span> <span class="keyword">final</span>;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a3840603cf5c461f2e13b61cbab0e3e90">cancelDirective</a>(<span class="keyword">const</span> std::string&amp; messageId) <span class="keyword">override</span> <span class="keyword">final</span>;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a534b6a5c2280f9fcd0866a82524bbca4">onDeregistered</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#ab63458984e8abac5b7fd8df22149cf9b">onFocusChanged</a>(<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a066217aef6bc1e0e18dd3a13f467d275">FocusState</a> newFocus) <span class="keyword">override</span>;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#af056b26452e6c4ca5855a72ec2bfcde4">provideState</a>(<span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">avsCommon::avs::NamespaceAndName</a>&amp; stateProviderName, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> stateRequestToken)</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keyword">override</span>;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#aa2ad8b4b2bbcf6070e2b6e9e13785322">onContextAvailable</a>(<span class="keyword">const</span> std::string&amp; jsonContext) <span class="keyword">override</span>;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#ae8f0c021b6eca42f22d5e0afe33cffdc">onContextFailure</a>(<span class="keyword">const</span> <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html#a8ec2f2403294717c740bfacf5c62d018">sdkInterfaces::ContextRequestError</a> error) <span class="keyword">override</span>;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a7254a7c71bc99bdeab87ae9a2c7dc5c8">CapabilityAgent</a>(</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <span class="keyword">const</span> std::string&amp; nameSpace,</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        std::shared_ptr&lt;sdkInterfaces::ExceptionEncounteredSenderInterface&gt; exceptionEncounteredSender);</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html">  101</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html">DirectiveInfo</a> {</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html#a8043c0e0fcc8272c251e1936ab4f7fc2">DirectiveInfo</a>(</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;            std::shared_ptr&lt;AVSDirective&gt; directiveIn,</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            std::unique_ptr&lt;sdkInterfaces::DirectiveHandlerResultInterface&gt; resultIn);</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        <span class="keyword">virtual</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html#a45a0b27903b8613efff13df5f776f3f3">~DirectiveInfo</a>() = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html#a1982e1987557bd66f084db026788d75e">  119</a></span>&#160;        std::shared_ptr&lt;AVSDirective&gt; <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html#a1982e1987557bd66f084db026788d75e">directive</a>;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html#a79d5adf5424eb507605ef413a1222e9a">  122</a></span>&#160;        std::shared_ptr&lt;sdkInterfaces::DirectiveHandlerResultInterface&gt; <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html#a79d5adf5424eb507605ef413a1222e9a">result</a>;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html#a9af8f2d6a83601dcca851910949529df">  125</a></span>&#160;        std::atomic&lt;bool&gt; <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html#a9af8f2d6a83601dcca851910949529df">isCancelled</a>;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    };</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <span class="keyword">virtual</span> std::shared_ptr&lt;DirectiveInfo&gt; <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a19f623357462b3e1a0b2f9c55743198b">createDirectiveInfo</a>(</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        std::shared_ptr&lt;AVSDirective&gt; directive,</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        std::unique_ptr&lt;sdkInterfaces::DirectiveHandlerResultInterface&gt; result);</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a6643447cdbecc1e49e14532b0cc83cf1">preHandleDirective</a>(std::shared_ptr&lt;DirectiveInfo&gt; info) = 0;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a971352c6a79f7cb000e5e632648bceb3">handleDirective</a>(std::shared_ptr&lt;DirectiveInfo&gt; info) = 0;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a3840603cf5c461f2e13b61cbab0e3e90">cancelDirective</a>(std::shared_ptr&lt;DirectiveInfo&gt; info) = 0;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a8818d802b24e4b2a69ddeac9c659199f">removeDirective</a>(<span class="keyword">const</span> std::string&amp; messageId);</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a2c522e09b9b367e75cf7f09a548f7bfe">sendExceptionEncounteredAndReportFailed</a>(</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        std::shared_ptr&lt;DirectiveInfo&gt; info,</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        <span class="keyword">const</span> std::string&amp; message,</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ae31d62036894f4c57c46d65dee1482fc">avsCommon::avs::ExceptionErrorType</a> type = <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ae31d62036894f4c57c46d65dee1482fcae8c0c70879b5895c615677261d64a1ee">avsCommon::avs::ExceptionErrorType::INTERNAL_ERROR</a>);</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    <span class="keyword">const</span> std::pair&lt;std::string, std::string&gt; <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a0141d9d834ebc600e75117d5fc791202">buildJsonEventString</a>(</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        <span class="keyword">const</span> std::string&amp; eventName,</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        <span class="keyword">const</span> std::string&amp; dialogRequestIdString = <span class="stringliteral">&quot;&quot;</span>,</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        <span class="keyword">const</span> std::string&amp; payload = <span class="stringliteral">&quot;{}&quot;</span>,</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        <span class="keyword">const</span> std::string&amp; context = <span class="stringliteral">&quot;&quot;</span>);</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;</div><div class="line"><a name="l00226"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a44fd59779e935c0548b4ec2938ee364b">  226</a></span>&#160;    <span class="keyword">const</span> std::string <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a44fd59779e935c0548b4ec2938ee364b">m_namespace</a>;</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;</div><div class="line"><a name="l00229"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#ac15d9611ab7ae14824cdf5fc52d79dc5">  229</a></span>&#160;    std::shared_ptr&lt;sdkInterfaces::ExceptionEncounteredSenderInterface&gt; <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#ac15d9611ab7ae14824cdf5fc52d79dc5">m_exceptionEncounteredSender</a>;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    std::shared_ptr&lt;DirectiveInfo&gt; getDirectiveInfo(<span class="keyword">const</span> std::string&amp; messageId);</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;    std::unordered_map&lt;std::string, std::shared_ptr&lt;DirectiveInfo&gt;&gt; m_directiveInfoMap;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;    std::mutex m_mutex;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;};</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;}  <span class="comment">// namespace avs</span></div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;}  <span class="comment">// namespace avsCommon</span></div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_AVSCOMMON_AVS_INCLUDE_AVSCOMMON_AVS_CAPABILITYAGENT_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html">alexaClientSDK::avsCommon::avs::CapabilityAgent</a></div><div class="ttdef"><b>Definition:</b> CapabilityAgent.h:47</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_a3840603cf5c461f2e13b61cbab0e3e90"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a3840603cf5c461f2e13b61cbab0e3e90">alexaClientSDK::avsCommon::avs::CapabilityAgent::cancelDirective</a></div><div class="ttdeci">void cancelDirective(const std::string &amp;messageId) override final</div><div class="ttdef"><b>Definition:</b> CapabilityAgent.cpp:98</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_a6643447cdbecc1e49e14532b0cc83cf1"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a6643447cdbecc1e49e14532b0cc83cf1">alexaClientSDK::avsCommon::avs::CapabilityAgent::preHandleDirective</a></div><div class="ttdeci">void preHandleDirective(std::shared_ptr&lt; AVSDirective &gt; directive, std::unique_ptr&lt; sdkInterfaces::DirectiveHandlerResultInterface &gt; result) override final</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">alexaClientSDK::avsCommon::avs::NamespaceAndName</a></div><div class="ttdef"><b>Definition:</b> NamespaceAndName.h:28</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_ac15d9611ab7ae14824cdf5fc52d79dc5"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#ac15d9611ab7ae14824cdf5fc52d79dc5">alexaClientSDK::avsCommon::avs::CapabilityAgent::m_exceptionEncounteredSender</a></div><div class="ttdeci">std::shared_ptr&lt; sdkInterfaces::ExceptionEncounteredSenderInterface &gt; m_exceptionEncounteredSender</div><div class="ttdoc">Object to use to send exceptionEncountered messages. </div><div class="ttdef"><b>Definition:</b> CapabilityAgent.h:229</div></div>
<div class="ttc" id="_state_provider_interface_8h_html"><div class="ttname"><a href="_state_provider_interface_8h.html">StateProviderInterface.h</a></div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_html_a8ec2f2403294717c740bfacf5c62d018"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html#a8ec2f2403294717c740bfacf5c62d018">alexaClientSDK::avsCommon::sdkInterfaces::ContextRequestError</a></div><div class="ttdeci">ContextRequestError</div><div class="ttdef"><b>Definition:</b> ContextRequesterInterface.h:32</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_ae31d62036894f4c57c46d65dee1482fc"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ae31d62036894f4c57c46d65dee1482fc">alexaClientSDK::avsCommon::avs::ExceptionErrorType</a></div><div class="ttdeci">ExceptionErrorType</div><div class="ttdef"><b>Definition:</b> ExceptionErrorType.h:28</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info_html_a1982e1987557bd66f084db026788d75e"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html#a1982e1987557bd66f084db026788d75e">alexaClientSDK::avsCommon::avs::CapabilityAgent::DirectiveInfo::directive</a></div><div class="ttdeci">std::shared_ptr&lt; AVSDirective &gt; directive</div><div class="ttdoc">AVSDirective that is passed during preHandle. </div><div class="ttdef"><b>Definition:</b> CapabilityAgent.h:119</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_ae8f0c021b6eca42f22d5e0afe33cffdc"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#ae8f0c021b6eca42f22d5e0afe33cffdc">alexaClientSDK::avsCommon::avs::CapabilityAgent::onContextFailure</a></div><div class="ttdeci">void onContextFailure(const sdkInterfaces::ContextRequestError error) override</div><div class="ttdef"><b>Definition:</b> CapabilityAgent.cpp:156</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_a066217aef6bc1e0e18dd3a13f467d275"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a066217aef6bc1e0e18dd3a13f467d275">alexaClientSDK::avsCommon::avs::FocusState</a></div><div class="ttdeci">FocusState</div><div class="ttdef"><b>Definition:</b> FocusState.h:28</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_a19f623357462b3e1a0b2f9c55743198b"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a19f623357462b3e1a0b2f9c55743198b">alexaClientSDK::avsCommon::avs::CapabilityAgent::createDirectiveInfo</a></div><div class="ttdeci">virtual std::shared_ptr&lt; DirectiveInfo &gt; createDirectiveInfo(std::shared_ptr&lt; AVSDirective &gt; directive, std::unique_ptr&lt; sdkInterfaces::DirectiveHandlerResultInterface &gt; result)</div><div class="ttdef"><b>Definition:</b> CapabilityAgent.cpp:43</div></div>
<div class="ttc" id="_directive_handler_interface_8h_html"><div class="ttname"><a href="_directive_handler_interface_8h.html">DirectiveHandlerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_af056b26452e6c4ca5855a72ec2bfcde4"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#af056b26452e6c4ca5855a72ec2bfcde4">alexaClientSDK::avsCommon::avs::CapabilityAgent::provideState</a></div><div class="ttdeci">void provideState(const avsCommon::avs::NamespaceAndName &amp;stateProviderName, const unsigned int stateRequestToken) override</div><div class="ttdef"><b>Definition:</b> CapabilityAgent.cpp:148</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_requester_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_requester_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::ContextRequesterInterface</a></div><div class="ttdef"><b>Definition:</b> ContextRequesterInterface.h:43</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_a534b6a5c2280f9fcd0866a82524bbca4"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a534b6a5c2280f9fcd0866a82524bbca4">alexaClientSDK::avsCommon::avs::CapabilityAgent::onDeregistered</a></div><div class="ttdeci">void onDeregistered() override</div><div class="ttdef"><b>Definition:</b> CapabilityAgent.cpp:134</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_a2c522e09b9b367e75cf7f09a548f7bfe"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a2c522e09b9b367e75cf7f09a548f7bfe">alexaClientSDK::avsCommon::avs::CapabilityAgent::sendExceptionEncounteredAndReportFailed</a></div><div class="ttdeci">void sendExceptionEncounteredAndReportFailed(std::shared_ptr&lt; DirectiveInfo &gt; info, const std::string &amp;message, avsCommon::avs::ExceptionErrorType type=avsCommon::avs::ExceptionErrorType::INTERNAL_ERROR)</div><div class="ttdef"><b>Definition:</b> CapabilityAgent.cpp:112</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::StateProviderInterface</a></div><div class="ttdef"><b>Definition:</b> StateProviderInterface.h:29</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_a7254a7c71bc99bdeab87ae9a2c7dc5c8"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a7254a7c71bc99bdeab87ae9a2c7dc5c8">alexaClientSDK::avsCommon::avs::CapabilityAgent::CapabilityAgent</a></div><div class="ttdeci">CapabilityAgent(const std::string &amp;nameSpace, std::shared_ptr&lt; sdkInterfaces::ExceptionEncounteredSenderInterface &gt; exceptionEncounteredSender)</div><div class="ttdef"><b>Definition:</b> CapabilityAgent.cpp:49</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info_html_a79d5adf5424eb507605ef413a1222e9a"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html#a79d5adf5424eb507605ef413a1222e9a">alexaClientSDK::avsCommon::avs::CapabilityAgent::DirectiveInfo::result</a></div><div class="ttdeci">std::shared_ptr&lt; sdkInterfaces::DirectiveHandlerResultInterface &gt; result</div><div class="ttdoc">DirectiveHandlerResultInterface. </div><div class="ttdef"><b>Definition:</b> CapabilityAgent.h:122</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info_html_a45a0b27903b8613efff13df5f776f3f3"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html#a45a0b27903b8613efff13df5f776f3f3">alexaClientSDK::avsCommon::avs::CapabilityAgent::DirectiveInfo::~DirectiveInfo</a></div><div class="ttdeci">virtual ~DirectiveInfo()=default</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_ae31d62036894f4c57c46d65dee1482fcae8c0c70879b5895c615677261d64a1ee"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#ae31d62036894f4c57c46d65dee1482fcae8c0c70879b5895c615677261d64a1ee">alexaClientSDK::avsCommon::avs::ExceptionErrorType::INTERNAL_ERROR</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_a8818d802b24e4b2a69ddeac9c659199f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a8818d802b24e4b2a69ddeac9c659199f">alexaClientSDK::avsCommon::avs::CapabilityAgent::removeDirective</a></div><div class="ttdeci">void removeDirective(const std::string &amp;messageId)</div><div class="ttdef"><b>Definition:</b> CapabilityAgent.cpp:138</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_channel_observer_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_channel_observer_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::ChannelObserverInterface</a></div><div class="ttdef"><b>Definition:</b> ChannelObserverInterface.h:28</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_ab6745fae4f7b144f64d34251c76d14f7"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#ab6745fae4f7b144f64d34251c76d14f7">alexaClientSDK::avsCommon::avs::CapabilityAgent::~CapabilityAgent</a></div><div class="ttdeci">virtual ~CapabilityAgent()=default</div></div>
<div class="ttc" id="_exception_encountered_sender_interface_8h_html"><div class="ttname"><a href="_exception_encountered_sender_interface_8h.html">ExceptionEncounteredSenderInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_ab63458984e8abac5b7fd8df22149cf9b"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#ab63458984e8abac5b7fd8df22149cf9b">alexaClientSDK::avsCommon::avs::CapabilityAgent::onFocusChanged</a></div><div class="ttdeci">void onFocusChanged(FocusState newFocus) override</div><div class="ttdef"><b>Definition:</b> CapabilityAgent.cpp:144</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_a0141d9d834ebc600e75117d5fc791202"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a0141d9d834ebc600e75117d5fc791202">alexaClientSDK::avsCommon::avs::CapabilityAgent::buildJsonEventString</a></div><div class="ttdeci">const std::pair&lt; std::string, std::string &gt; buildJsonEventString(const std::string &amp;eventName, const std::string &amp;dialogRequestIdString=&quot;&quot;, const std::string &amp;payload=&quot;{}&quot;, const std::string &amp;context=&quot;&quot;)</div><div class="ttdef"><b>Definition:</b> CapabilityAgent.cpp:160</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::DirectiveHandlerInterface</a></div><div class="ttdef"><b>Definition:</b> DirectiveHandlerInterface.h:39</div></div>
<div class="ttc" id="_channel_observer_interface_8h_html"><div class="ttname"><a href="_channel_observer_interface_8h.html">ChannelObserverInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_a44fd59779e935c0548b4ec2938ee364b"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a44fd59779e935c0548b4ec2938ee364b">alexaClientSDK::avsCommon::avs::CapabilityAgent::m_namespace</a></div><div class="ttdeci">const std::string m_namespace</div><div class="ttdoc">The namespace of the capability agent. </div><div class="ttdef"><b>Definition:</b> CapabilityAgent.h:226</div></div>
<div class="ttc" id="_namespace_and_name_8h_html"><div class="ttname"><a href="_namespace_and_name_8h.html">NamespaceAndName.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html">alexaClientSDK::avsCommon::avs::CapabilityAgent::DirectiveInfo</a></div><div class="ttdef"><b>Definition:</b> CapabilityAgent.h:101</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_aa2ad8b4b2bbcf6070e2b6e9e13785322"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#aa2ad8b4b2bbcf6070e2b6e9e13785322">alexaClientSDK::avsCommon::avs::CapabilityAgent::onContextAvailable</a></div><div class="ttdeci">void onContextAvailable(const std::string &amp;jsonContext) override</div><div class="ttdef"><b>Definition:</b> CapabilityAgent.cpp:152</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html_a971352c6a79f7cb000e5e632648bceb3"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a971352c6a79f7cb000e5e632648bceb3">alexaClientSDK::avsCommon::avs::CapabilityAgent::handleDirective</a></div><div class="ttdeci">bool handleDirective(const std::string &amp;messageId) override final</div><div class="ttdef"><b>Definition:</b> CapabilityAgent.cpp:88</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info_html_a8043c0e0fcc8272c251e1936ab4f7fc2"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html#a8043c0e0fcc8272c251e1936ab4f7fc2">alexaClientSDK::avsCommon::avs::CapabilityAgent::DirectiveInfo::DirectiveInfo</a></div><div class="ttdeci">DirectiveInfo(std::shared_ptr&lt; AVSDirective &gt; directiveIn, std::unique_ptr&lt; sdkInterfaces::DirectiveHandlerResultInterface &gt; resultIn)</div><div class="ttdef"><b>Definition:</b> CapabilityAgent.cpp:56</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info_html_a9af8f2d6a83601dcca851910949529df"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_1_1_directive_info.html#a9af8f2d6a83601dcca851910949529df">alexaClientSDK::avsCommon::avs::CapabilityAgent::DirectiveInfo::isCancelled</a></div><div class="ttdeci">std::atomic&lt; bool &gt; isCancelled</div><div class="ttdoc">Flag to indicate whether the directive is cancelled. </div><div class="ttdef"><b>Definition:</b> CapabilityAgent.h:125</div></div>
<div class="ttc" id="_context_requester_interface_8h_html"><div class="ttname"><a href="_context_requester_interface_8h.html">ContextRequesterInterface.h</a></div></div>
<div class="ttc" id="_directive_handler_result_interface_8h_html"><div class="ttname"><a href="_directive_handler_result_interface_8h.html">DirectiveHandlerResultInterface.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
